import java.awt.*;
import java.io.*;
import java.util.*;

class realmlands extends Frame
{
static Frame f;
MenuBar mb;
Menu m1,m2, m3, menu_world;
MenuItem m1_new,m1_open,m1_save,m1_preview,m1_quit;
Graphics offGraphics;
Image offImage;
Dimension offDimension;
int zoom = 1;

SimulationMgr simmgr;

public realmlands()
{
  setTitle("Realmlands Test");
  setBackground(Color.lightGray);
  setLayout(new BorderLayout());
  mb = new MenuBar();
  setMenuBar(mb);
        
  m1 = new Menu("File");
  mb.add(m1);
  m1_new = new MenuItem("New");
  m1.add(m1_new);
  m1.addSeparator();
  m1_open = new MenuItem("Open");
  m1.add(m1_open);
  m1_save = new MenuItem("Save");
  m1.add(m1_save);
  m1.addSeparator();
  m1_quit = new MenuItem("Quit");
  m1.add(m1_quit);
  
  menu_world = new Menu("World");
  menu_world.add(new MenuItem("Create New"));
  mb.add(menu_world);
  
  
		
	m2 = new Menu("Tools");
	Menu zoom = new Menu("Zoom");
	zoom.add(new MenuItem("Normal"));
	zoom.addSeparator();
	zoom.add(new MenuItem("Larger"));		
	zoom.add(new MenuItem("Smaller"));						
	m2.add(zoom);		
	m2.add(new MenuItem("Refresh"));
	mb.add(m2);
		
	m3 = new Menu("Filter");
	m3.add(new MenuItem("Red"));
	m3.add(new MenuItem("Green"));		
	m3.add(new MenuItem("Blue"));
	m3.addSeparator();
	m3.add(new MenuItem("MipMap"));
	m3.add(new MenuItem("MipMap 2x"));
	m3.add(new MenuItem("MipMap 5x"));		
	mb.add(m3);
		
	Menu simulation = new Menu("Simulation");
	simulation.add("Start");
	simulation.add("Pause");
	simulation.addSeparator();		
	simulation.add("Stop");		
	mb.add(simulation);

  simmgr = new SimulationMgr();
 
  add("Center", simmgr.GetSimulationCanvas());
  add("East", simmgr.GetTestCanvas());  
}

public boolean action(Event evt, Object arg)      
{
  if(arg.equals("Quit"))
  {
    System.exit(0);
  }else
  if(arg.equals("Create New"))
  {
    simmgr.CreateNewWorld();
  }else
  if(arg.equals("MipMap"))
  {
    simmgr.MipMap(1);
  }
  if(arg.equals("MipMap 2x"))
  {
    simmgr.MipMap(2);
  }
  if(arg.equals("MipMap 5x"))
  {
    simmgr.MipMap(5);  
  }else  
  if(arg.equals("Refresh"))
  {
  	repaint();
  }
  else
  if(arg.equals("Red"))
  {
   simmgr.SharpenRed();
  }
  else
  if(arg.equals("Green"))
  {
      simmgr.SharpenGreen();
  }
  else
  if(arg.equals("Blue"))
  {
      simmgr.SharpenBlue();
  }else
  if(arg.equals("Normal"))
  {
	  //zoom = 1;
	  //repaint();
  }else
  if(arg.equals("Larger"))
  {
    simmgr.ZoomIn();
	  repaint();
  }else
  if(arg.equals("Smaller"))
  {
    simmgr.ZoomOut();
	  repaint();
	}else 
  if(arg.equals("Start"))
  {
    simmgr.start();
  }
	  
  return false;
}
  
public boolean mouseDrag(Event event, int x, int y)
   {
   Point point=null;
        if (point == null)
         {
             point = new Point(x,y);
         }
        point.x = x;
        point.y = y;

return false;
}//end mousedrag

public boolean mouseDown(Event event, int x, int y)
   {
   Point point=null;
        if (point == null)
         {
             point = new Point(x,y);
         }
        point.x = x;
        point.y = y;
		/*
		int i, j;
		i = (x - x_picture_offset);
		j = (y - y_picture_offset);
		
		if((i > sizex)&&(j > sizey))
	    {		 
		}else
	    {
		 System.out.println(picture[i][j].getRed()+" "+picture[i][j].getGreen()+" "+picture[i][j].getBlue());
		}
		*/
		
		//System.out.println("x "+(x - x_picture_offset)+" y"+(y - y_picture_offset));
   return false;
   }

public boolean keyDown(Event e, int key)
{
  return false;
}


/*
public void update(Graphics g)
{
  
  //doublebuffering code
Dimension d = size();

//Create the offscreen graphics context, if no good one exists.
        if ((offGraphics == null) || (d.width != offDimension.width) || (d.height != offDimension.height))
           { offDimension = d;
             offImage = createImage(d.width, d.height);
             offGraphics = offImage.getGraphics();
           }
        //Erase the previous image.
        offGraphics.setColor(getBackground());
        offGraphics.fillRect(0, 0, d.width, d.height);
        offGraphics.setColor(Color.lightGray);

for (int i = 0;i<sizex; i++)
{
  for (int j = 0;j<sizey; j++)
  {
    //offGraphics.setColor(colors[picture[i][j]]);
	offGraphics.setColor(picture[j][i]);
    offGraphics.fillRect(x_picture_offset+1+(j*zoom),y_picture_offset+1+(i*zoom),zoom,zoom);//picture[i][j]=255;
    //offGraphics.fillRect((x_picture_offset)+picture_size+11+i,y_picture_offset+1+j,1,1);//picture[i][j]=255;
  }
}


//simmgr.repaint(offGraphics);

g.drawImage(offImage, 0, 0, this);
}

public void paint(Graphics g)
{
update(g);
}
*/
public boolean handleEvent(Event e)
   {
   if (e.id == Event.WINDOW_DESTROY)
      {
         System.exit(0);
      }
      return super.handleEvent(e);
   }

public static void main(String[] args)
   {
      f = new realmlands();
      f.setSize(400,480);
      f.setVisible(true);
   }
}
