import java.awt.*;
import java.util.*;

public class SimulationCanvas extends Canvas
{
	
public SimulationCanvas( int x, int y, Color[][] map)
{  
  
	sizex = x;
	sizey = y;
  setSize(sizex+1, sizey+1);
  
  if(map == null)
  {
    picture = new Color[sizex][sizey];
    for (int i = 0;i<sizex; i++)
    {
      for (int j = 0;j<sizey; j++)
      { 
    	  picture[j][i] = Color.black;
      }
    }    
  }
    else
	  picture = map;//new Color[sizex][sizey];
	Init();
}

public void Init()
{
/*
 for (int i = 0;i<sizex; i++)
 {
   for (int j = 0;j<sizey; j++)
   { 
	  picture[j][i] = new Color(180,180,180);
   }
 }
*/
 
 //CreateStatic();
}

/*
public void CreateStatic()
{
 for(int i = 0; i < sizex; i++)
 {
  for(int j = 0; j < sizey; j++)
  {

   //Color color
   int r, g, b;
   r = R.nextInt() % 256;   
   if(r < 0) r = -r;
   //R = new Random(r);   
   
   g = R.nextInt() % 256;
   if(g < 0) g = -g;   
   //R = new Random(g);

   b = R.nextInt() % 256;
   if(b < 0) b = -b;
   picture[j][i] = new Color(r, g, b);
   //System.out.println(r+" "+g+" "+b);
  }
 }
}
*/

public void update(Graphics g)
{
 //System.out.println("Draw");
 g.setColor(Color.black);	  
 g.drawRect(0,0, (sizex*zoom)+1, (sizey*zoom)+1);
	
 for (int i = 0;i<sizex; i++)
 {
   for (int j = 0;j<sizey; j++)
   { 
    //g.setColor(new Color(100,150,37));
    //g.fillRect(100,100,50,50);
	   g.setColor(picture[j][i]);
	   g.fillRect((j*zoom)+1, (i*zoom)+1, 1*zoom, 1*zoom);
	  
   }
 }

 //g.setColor(Color.black);	   
 //g.drawString("SimulationCanvas", 2, 15);	
}

public void paint(Graphics g)
{
update(g);
} 

public void refresh()
{
 repaint();
}

public void ZoomIn()
{
  zoom++;
  
  setSize(sizex*zoom, sizey*zoom);
}

public void ZoomOut()
{
  if(zoom > 1)
  {
    zoom--;
    setSize(sizex*zoom, sizey*zoom);    
  }
}

public void SetMap(Color[][] map)
{
  picture = map;
  repaint();
}


int sizex = 1, sizey = 1;
int zoom = 1;
Color picture[][];
Random R = new Random();

}
